Box(T) - Crystal 1.19.1

# class Box(T)

- Box(T)
- Reference
- Object

##
Overview

A Box allows turning any object to a `Void*` and back.

A Box's purpose is passing data to C as a `Void*` and then converting that back to the original data type.

For an example usage, see `Proc`'s explanation about sending Procs to C.

##
Defined in:

box.cr

##
Class Method Summary

- .box(object : T) : Pointer(Void)

  Turns object into a `Void*`.

- .unbox(pointer : Pointer(Void)) : T

  Unboxes a `Void*` into an object of type `T`.

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Class Method Detail

def self.box(object : T) : Pointer(Void) #

Turns object into a `Void*`.

If `T` is not a reference or pointer type, nor a union between reference types and `Nil`, this method effectively copies object to the dynamic heap.

NOTE The returned pointer might not be a null pointer even when object is `nil`.

def self.unbox(pointer : Pointer(Void)) : T #

Unboxes a `Void*` into an object of type `T`. Note that for this you must specify T: `Box(T).unbox(data)`.

Raises `NilAssertionError` if pointer is null and `T` is not nilable.

WARNING It is undefined behavior to box an object in one type and unbox it via a different type; in particular, when boxing a `T` and unboxing it as a `T?`, or vice-versa.